// =====================================================================
//  main.c
// =====================================================================

//  Author:         (c) 2014 Camil Demetrescu
//  License:        See the end of this file for license information
//  Created:        June 16, 2014

//  Last changed:   $Date: 2014/06/16 15:00:07 $
//  Changed by:     $Author: demetres $
//  Revision:       $Revision: 1.00 $

#include <stdio.h>
#include <stdarg.h>
#include "stack.h"

void print(int n, ...);

// ---------------------------------------------------------------------
// main
// ---------------------------------------------------------------------
int main() {
	int err;
	stack* s =                    stack_init();
	print (1, "push",       10);  stack_push(&s, 10);
	print (1, "push",       20);  stack_push(&s, 20);
	print (1, "push",       30);  stack_push(&s, 30);
	print (2, "isempty ->",  0,   stack_isempty(s));
	print (2, "top ->",     30,   stack_top(s, &err));
	print (2, "err ->",      0,   err);
	print (2, "pop ->",     30,   stack_pop(&s, &err));
	print (2, "err ->",      0,   err);
	print (2, "pop ->",     20,   stack_pop(&s, NULL));
	print (1, "push",       15);  stack_push(&s, 15);
	print (2, "pop ->",     15,   stack_pop(&s, NULL));
	print (2, "pop ->",     10,   stack_pop(&s, NULL));
	print (2, "isempty ->",  1,   stack_isempty(s));
	print (2, "pop ->",      0,   stack_pop(&s, &err));
	print (2, "err ->",      1,   err);
	print (2, "top ->",      0,   stack_top(s, &err));
	print (2, "err ->",      1,   err);
	print (1, "push",       10);  stack_push(&s, 10);
	print (1, "push",       20);  stack_push(&s, 20);
	print (1, "push",       30);  stack_push(&s, 30);
	print (0, "popall");          stack_popall(&s);
	print (2, "isempty ->",  1,   stack_isempty(s));
	return 0;
}


// ---------------------------------------------------------------------
// print
// ---------------------------------------------------------------------
void print(int n, ...) {
	va_list va;
	va_start(va, n);
	printf("%-10s", va_arg(va, char*));
	if (n>0) printf("%3d ", va_arg(va, int));
	if (n>1) printf(" [corretto: %2d]", va_arg(va, int));
	printf("\n");
	va_end(va);
}
