// =====================================================================
//  stack.c
// =====================================================================

//  Author:         (c) 2014 Camil Demetrescu
//  License:        See the end of this file for license information
//  Created:        June 16, 2014

//  Last changed:   $Date: 2014/06/16 15:00:07 $
//  Changed by:     $Author: demetres $
//  Revision:       $Revision: 1.00 $


#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include "stack.h"


struct stack {
	int    elem;
	stack* next;
};


// ---------------------------------------------------------------------
// stack_init
// ---------------------------------------------------------------------
stack* stack_init() {
	return NULL;
}


// ---------------------------------------------------------------------
// stack_isempty
// ---------------------------------------------------------------------
int stack_isempty(const stack* s) {
	return s == NULL;
}


// ---------------------------------------------------------------------
// stack_push
// ---------------------------------------------------------------------
void stack_push(stack** s, int e) {
	stack* p = malloc(sizeof(stack));
	assert(p != NULL);
	p->elem = e;
	p->next = *s;
	*s = p;
}


// ---------------------------------------------------------------------
// stack_pop
// ---------------------------------------------------------------------
int stack_pop(stack** s, int* err) {
	stack* dead = *s;
	if (stack_isempty(*s)) {
		if (err) *err = 1;
		return 0;
	}
	int elem = (*s)->elem;
	*s = (*s)->next;
	free(dead);
	if (err) *err = 0;
	return elem;
}


// ---------------------------------------------------------------------
// stack_top
// ---------------------------------------------------------------------
int stack_top(const stack* s, int* err) {
	if (stack_isempty(s)) {
		if (err) *err = 1;
		return 0;
	}
	if (err) *err = 0;
	return s->elem;
}


// ---------------------------------------------------------------------
// stack_popall
// ---------------------------------------------------------------------
void stack_popall(stack** s) {
	while (!stack_isempty(*s)) 
		stack_pop(s, NULL);
}

